USE master;
go
alter database CorpDBExpanded set auto_create_statistics off;
go
alter database CorpDBExpanded set auto_update_statistics off with no_wait;
go
use CorpDBExpanded;
go
alter database scoped configuration set maxdop = 1;
go

alter table CorpDBExpanded.dbo.Customer
alter column FirstName nvarchar(50) not null;

alter table CorpDBExpanded.dbo.Customer
alter column LastName nvarchar(50) not null;
go

create nonclustered index idx_Customer__LastName on dbo.Customer (LastName);
go

declare @ctr int = 1
declare @customersToGenerate int = 10000;
while @ctr <= 93
begin
	with l0 as (select 1 v union all select 1), l1 as (select a.v from l0 a, l0), l2 as (select a.v from l1 a, l1),
	l3 as (select a.v from l2 a, l2), l4 as (select a.v from l3 a, l3), l5 as (select a.v from l4 a, l4),
	Nums as (select row_number() over (order by (select null)) n from l5),
	RandomValues as
	(
		select	(binary_checksum(newid()) + 2147483648.) / 4294967296. r1,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r2,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r3,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r4,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r5,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r6,
				(binary_checksum(newid()) + 2147483648.) / 4294967296. r7
		from	Nums n
		where	n.n <= @customersToGenerate
	)
	insert CorpDBExpanded.dbo.Customer (FirstName, LastName, Address, City, State)
	select cust.FirstName, 'Ming' /*cust.LastName*/, cust.Address, cust.City, cust.State
	--select 'Maria' /*cust.FirstName*/, 'Maria' /*cust.LastName*/, cust.Address, cust.City, cust.State
	from RandomValues
	cross apply CorpDBExpanded.dbo.fnGenerateRandomCustomer(r1, r2, r3, r4, r5, r6, r7) cust;

	select @ctr += 1;
end
go

--update statistics dbo.Customer (idx_Customer__LastName) with rowcount=100, pagecount=20;
