use CorpDB;
go

----------------------------------------------------------------------------------------------------
-- First, create the following function
----------------------------------------------------------------------------------------------------
drop function if exists dbo.GetLine1ProductId;
go
create function dbo.GetLine1ProductId (@OrderId int)
returns int
as
begin
	declare @ProductId int;

	select top 1 @ProductId = od.ProductId
	from dbo.OrderDetail od
	where od.OrderId = @OrderId
	order by od.OrderDetailId;

	return @ProductId;
end
go

----------------------------------------------------------------------------------------------------
-- Now get an ACTUAL execution plan on this statement.
-- Note the cost of the overall plan and the cost of the TVF operator
----------------------------------------------------------------------------------------------------
select oh.OrderId,
	oh.OrderDate,
	oh.CustomerId,
	dbo.GetLine1ProductId(oh.OrderId) Line1ProductId
from dbo.OrderHeader oh
where oh.OrderDate >= '2016-05-10';

----------------------------------------------------------------------------------------------------
-- Then get an ESTIMATED execution plan on the same statement.
----------------------------------------------------------------------------------------------------
select oh.OrderId,
	oh.OrderDate,
	oh.CustomerId,
	dbo.GetLine1ProductId(oh.OrderId) Line1ProductId
from dbo.OrderHeader oh
where oh.OrderDate >= '2016-05-10';
